﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=11.2
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	Private xui As XUI
	Private wmCalendar1 As wmCalendar
End Sub

Sub Globals
	Private chkAllDay As CheckBox
	Private Label1 As Label
	Private Label3 As Label
	Private Label4 As Label
	Private Label6 As Label
	Private Label8 As Label
	Private labelDate As Label
	Private lblID As Label
	Private Panel1 As Panel
	Private txtDescription As EditText
	Private InputTemplate As B4XInputTemplate
	Private txtLocation As EditText
	Private txtOrganiser As EditText
	Private txtTitle As EditText
	Private DateTemplate As B4XDateTemplate
	Private Dialog As B4XDialog
	Private xui As XUI
	Private btnCancel As Button
	Private btnSave As Button
	Private Base As B4XView
	Private InputTemplate As B4XInputTemplate
	Private btnTimeFrom As SwiftButton
	Private btnTimeTo As SwiftButton
	Private lblFrom As Label
	Private lblTo As Label
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("appointmentsadd")
	Base = Activity
	Dialog.Initialize (Base)
	InputTemplate.Initialize
	DateTemplate.Initialize
	DateTemplate.Date = Main.DateRet
	txtOrganiser.Text = ""
	txtTitle.Text = ""
	txtLocation.Text = ""
	txtDescription.Text = ""
	btnTimeFrom.xLBL.Text = ""
	btnTimeTo.xLBL.Text = ""
	chkAllDay.Checked = False
	DateTemplate.Date = Main.DateRet
	Dialog.Initialize(Activity)
	wmCalendar1.Initialize
	UpdateLabel
End Sub

Sub btnTimeFrom_Click
	InputTemplate.lblTitle.Text = "Time From (00:00)"
	InputTemplate.RegexPattern = "^([0-9]|0[0-9]|1[0-9]|2[0-3]):[0-5][0-9]$" '<---optional. Remove if not needed
	Wait For (Dialog.ShowTemplate(InputTemplate, "OK", "", "CANCEL")) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		btnTimeFrom.xLBL.Text = InputTemplate.Text
	End If
End Sub

Sub btnTimeto_Click
	InputTemplate.lblTitle.Text = "Time To (00:00)"
	InputTemplate.RegexPattern = "^([0-9]|0[0-9]|1[0-9]|2[0-3]):[0-5][0-9]$" '<---optional. Remove if not needed
	Wait For (Dialog.ShowTemplate(InputTemplate, "OK", "", "CANCEL")) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		btnTimeTo.xLBL.Text = InputTemplate.Text
	End If
End Sub


Sub chkAllDay_Click
	If chkAllDay.Checked = True Then 
		btnTimeFrom.Enabled = False '  .xLBL.Visible = False
		btnTimeTo.Enabled = False ' xLBL.Visible = False
	End If
	If chkAllDay.Checked = False Then 
		btnTimeFrom.Enabled = True ' xLBL.Visible = True
		btnTimeTo.Enabled = True ' xLBL.Visible = True
	End If
End Sub

Sub btnSave_Click
	Dim theEvent As EventInfo
	DateTime.DateFormat = "yyyy-MM-dd HH:mm:ss"
	DateTime.TimeFormat =  "HH:mm"
	Dim ChkDate As String = DateTime.Date(Main.AddorEditDate)
	Dim econValues As List
	econValues.Initialize
	econValues.Add(Main.wmCalendar1.econ.ALL_DAY)
	econValues.Add(Main.wmCalendar1.econ.DESCRIPTION)
	econValues.Add(Main.wmCalendar1.econ.DTEND)
	econValues.Add(Main.wmCalendar1.econ.DTSTART)
	econValues.Add(Main.wmCalendar1.econ.TITLE)
	econValues.Add(Main.wmCalendar1.econ.ORGANIZER)
	econValues.Add(Main.wmCalendar1.econ.LOCATION)
	econValues.Add(Main.wmCalendar1.econ.EVENT_END_TIMEZONE)
	econValues.Add(Main.wmCalendar1.econ.EVENT_TIMEZONE)
	If chkAllDay.Checked = True Then
		Dim theEvent As EventInfo
		theEvent.Initialize
		theEvent.visible = 1
		theEvent.allDay = 1
		theEvent.description = txtDescription.Text
		theEvent.dateTimeStart = DateTime.Add(TodayStartAsUTCticks, 0, 0, 1) 
		theEvent.dateTimeEnd = DateTime.Add(TodayStartAsUTCticks, 0, 0, 1)
		theEvent.title = txtTitle.Text
		theEvent.organizer = txtOrganiser.Text
		theEvent.location = txtLocation.Text
		theEvent.timeZone = Main.STimeZone
		theEvent.endTimeZone = Main.STimeZone
	Else
		If btnTimeFrom.xLBL.Text = "" Then 'needs better error checking
			Msgbox("No time entered or All day not checked", "Time(s) or All day required")
			Return
		End If
		Dim	tfrom As Long =  DateTime.datetimeParse(ChkDate,btnTimeFrom.xLBL.Text)
		Dim tTo As Long = DateTime.datetimeParse(ChkDate,btnTimeTo.xLBL.Text)
		Dim theEvent As EventInfo
		theEvent.Initialize
		theEvent.visible = 1
		theEvent.allDay = 0
		theEvent.description = txtDescription.Text
		theEvent.dateTimeEnd = tTo
		theEvent.dateTimeStart =tfrom
		theEvent.title = txtTitle.Text
		theEvent.organizer = txtOrganiser.Text
		theEvent.location = txtLocation.Text
		theEvent.timeZone = Main.STimeZone
		theEvent.endTimeZone = Main.STimeZone
	End If
	Dim newEventID As Int = Main.wmCalendar1.AddEvent(Main.ScalendarID, theEvent, econValues)
	If newEventID < 0 Then
		Msgbox("The Entry could not be added", "DITL Calendar")
	Else
		Msgbox("The Entry has been added", "DITL Calendar")
	End If
	StartActivity(Main)
End Sub

Private Sub TodayStartAsUTCticks As Long
	DateTime.DateFormat = "yyyyMMdd"
	Dim TheDay As String = DateTime.Date(Main.DateRet)
	DateTime.DateFormat = "yyyyMMddHHmmss"
	TheDay = TheDay & "000000"
	Dim dateOut As Long =  DateTime.DateParse(TheDay) - (DateTime.TicksPerHour * DateTime.TimeZoneOffset)
	DateTime.DateFormat = Main.originalDateFormat
	Return dateOut
End Sub

Sub btnCancel_Click
	StartActivity(Main)
End Sub

Sub UpdateLabel
	DateTime.DateFormat = "dd/MM/yyyy"
	labelDate.Text = $"Selected Date: $Date{DateTemplate.Date}"$
End Sub

Sub labelDate_Click
	Wait For (Dialog.ShowTemplate(DateTemplate, "", "", "CANCEL")) Complete (Result As Int)
	UpdateLabel
End Sub

Sub Activity_Resume
	txtOrganiser.Text = ""
	txtTitle.Text = ""
	txtLocation.Text = ""
	txtDescription.Text = ""
	btnTimeFrom.xLBL.Text = ""
	btnTimeTo.xLBL.Text = ""
	chkAllDay.Checked = False
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	
End Sub