﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=11.2
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals

End Sub

Sub Globals
	Public chkday As Int
	Private tfrom, tto As Long
	Private btnCancel As Button
	Private btnSave As Button
	Private btnTimeFrom As SwiftButton
	Private btnTimeTo As SwiftButton
	Private chkAllDay As CheckBox
	Public chkBox As String
	Private DateTemplate As B4XDateTemplate
	Private Dialog As B4XDialog
	Private xui As XUI
	Private labelDate As Label
	Private lblID As Label
	Private Panel1 As Panel
	Private txtDescription As EditText
	Private txtLocation As EditText
	Private txtOrganiser As EditText
	Private txtTitle As EditText
	Private Base As B4XView
	Private InputTemplate As B4XInputTemplate
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("appointmentedit")
	Base = Activity
	Dialog.Initialize (Base)
	InputTemplate.Initialize
	DateTemplate.Initialize
	DateTemplate.Date = Main.DateRet
	Dim selectedEvent As EventInfo
	selectedEvent = Main.wmCalendar1.GetEventByID(Main.EventID)
	txtTitle.Text =  selectedEvent.title
	chkBox =  selectedEvent.allDay
	If chkBox = 0 Then chkAllDay.Checked = False
	If chkBox = 1 Then chkAllDay.Checked = True
	btnTimeFrom.xLBL.Text = DateTime.Time(selectedEvent.dateTimeStart)
	btnTimeTo.xLBL.Text = DateTime.Time(selectedEvent.dateTimeEnd)
	txtLocation.Text = selectedEvent.location
	txtDescription.Text =  selectedEvent.description
	txtOrganiser.Text = selectedEvent.organizer
	Dim ChkDate As String = DateTime.Date(Main.DateRet)
	If chkAllDay.Checked = True Then
		btnTimeFrom.Enabled = False '  .xLBL.Visible = False
		btnTimeTo.Enabled = False ' xLBL.Visible = False
		chkday = 1
	Else
		Dim	tfrom As Long =  DateTime.datetimeParse(ChkDate,btnTimeFrom.xLBL.Text)
		Dim tto As Long = DateTime.datetimeParse(ChkDate,btnTimeTo.xLBL.Text)
		chkday = 0
	End If
	Dialog.Initialize(Activity)
	DateTemplate.Date = Main.DateRet
	UpdateLabel
End Sub

Sub btnSave_Click
	Dim chkday As Int
	Dim theEvent As EventInfo
	DateTime.DateFormat = "yyyy-MM-dd HH:mm:ss"
	DateTime.TimeFormat =  "HH:mm"
	Dim ChkDate As String = DateTime.Date(Main.DateRet)
	Dim econValues As List
	econValues.Initialize
	econValues.Add(Main.wmCalendar1.econ.ALL_DAY)
	econValues.Add(Main.wmCalendar1.econ.DESCRIPTION)
	econValues.Add(Main.wmCalendar1.econ.DTEND)
	econValues.Add(Main.wmCalendar1.econ.DTSTART)
	econValues.Add(Main.wmCalendar1.econ.TITLE)
	econValues.Add(Main.wmCalendar1.econ.ORGANIZER)
	econValues.Add(Main.wmCalendar1.econ.LOCATION)
	econValues.Add(Main.wmCalendar1.econ.EVENT_END_TIMEZONE)
	econValues.Add(Main.wmCalendar1.econ.EVENT_TIMEZONE)
	If chkAllDay.Checked = True Then
		Dim theEvent As EventInfo
		theEvent.Initialize
		theEvent.visible = 1
		theEvent.allDay = 1
		theEvent.description = txtDescription.Text
		theEvent.dateTimeStart = DateTime.Add(TodayStartAsUTCticks, 0, 0, 1)
		theEvent.dateTimeEnd = DateTime.Add(TodayStartAsUTCticks, 0, 0, 1)
		theEvent.title = txtTitle.Text
		theEvent.organizer = txtOrganiser.Text
		theEvent.location = txtLocation.Text
		theEvent.timeZone = Main.STimeZone
		theEvent.endTimeZone = Main.STimeZone
	Else
		If btnTimeFrom.xLBL.Text = "" Then 'needs better error checking
			Msgbox("No time entered or All day not checked", "Time(s) or All day required")
			Return
		End If
		Dim	tfrom As Long =  DateTime.datetimeParse(ChkDate,btnTimeFrom.xLBL.Text)
		Dim tto As Long = DateTime.datetimeParse(ChkDate,btnTimeTo.xLBL.Text)
		Dim theEvent As EventInfo
		theEvent.Initialize
		theEvent.visible = 1
		theEvent.allDay = 0
		theEvent.description = txtDescription.Text
		theEvent.dateTimeEnd = tto
		theEvent.dateTimeStart =tfrom
		theEvent.title = txtTitle.Text
		theEvent.organizer = txtOrganiser.Text
		theEvent.location = txtLocation.Text
		theEvent.timeZone = Main.STimeZone
		theEvent.endTimeZone = Main.STimeZone
	End If
	Msgbox(Main.wmCalendar1.UpdateEvent(Main.EventID, theEvent, econValues) & " Event were updated", Application.LabelName)
	StartActivity(Main)
End Sub

Sub chkAllDay_Click
	If chkAllDay.Checked = True Then
		btnTimeFrom.Enabled = False '  .xLBL.Visible = False
		btnTimeTo.Enabled = False ' xLBL.Visible = False
	End If
	If chkAllDay.Checked = False Then
		btnTimeFrom.Enabled = True ' xLBL.Visible = True
		btnTimeTo.Enabled = True ' xLBL.Visible = True
	End If
End Sub

Private Sub TodayStartAsUTCticks As Long
	DateTime.DateFormat = "yyyyMMdd"
	Dim TheDay As String = DateTime.Date(Main.DateRet)
	DateTime.DateFormat = "yyyyMMddHHmmss"
	TheDay = TheDay & "000000"
	Dim dateOut As Long =  DateTime.DateParse(TheDay) - (DateTime.TicksPerHour * DateTime.TimeZoneOffset)
	DateTime.DateFormat = Main.originalDateFormat
	Return dateOut
End Sub

Sub btnCancel_Click
	StartActivity(Main)
End Sub


Sub btnTimeFrom_Click
	InputTemplate.lblTitle.Text = "Time From (00:00)"
	InputTemplate.RegexPattern = "^([0-9]|0[0-9]|1[0-9]|2[0-3]):[0-5][0-9]$" '<---optional. Remove if not needed
	Wait For (Dialog.ShowTemplate(InputTemplate, "OK", "", "CANCEL")) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		btnTimeFrom.xLBL.Text = InputTemplate.Text
	End If
End Sub

Sub btnTimeto_Click
	InputTemplate.lblTitle.Text = "Time To (00:00)"
	InputTemplate.RegexPattern = "^([0-9]|0[0-9]|1[0-9]|2[0-3]):[0-5][0-9]$" '<---optional. Remove if not needed
	Wait For (Dialog.ShowTemplate(InputTemplate, "OK", "", "CANCEL")) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		btnTimeTo.xLBL.Text = InputTemplate.Text
	End If
End Sub

Sub UpdateLabel
	DateTime.DateFormat = "dd/MM/yyyy"
	labelDate.Text = $"Selected Date: $Date{DateTemplate.Date}"$
End Sub

Sub labelDate_Click
	Wait For (Dialog.ShowTemplate(DateTemplate, "", "", "CANCEL")) Complete (Result As Int)
	UpdateLabel
End Sub

Sub Activity_Resume
	Activity.LoadLayout("appointmentedit")
	Base = Activity
	Dialog.Initialize (Base)
	InputTemplate.Initialize
	DateTemplate.Initialize
	DateTemplate.Date = Main.DateRet
	Dim selectedEvent As EventInfo
	selectedEvent = Main.wmCalendar1.GetEventByID(Main.EventID)
	txtTitle.Text =  selectedEvent.title
	chkBox =  selectedEvent.allDay
	If chkBox = 0 Then chkAllDay.Checked = False
	If chkBox = 1 Then chkAllDay.Checked = True
	btnTimeFrom.xLBL.Text = DateTime.Time(selectedEvent.dateTimeStart)
	btnTimeTo.xLBL.Text = DateTime.Time(selectedEvent.dateTimeEnd)
	txtLocation.Text = selectedEvent.location
	txtDescription.Text =  selectedEvent.description
	txtOrganiser.Text = selectedEvent.organizer
	Dim ChkDate As String = DateTime.Date(Main.DateRet)
	If chkAllDay.Checked = True Then
		Log("checked")
		btnTimeFrom.Enabled = False '  .xLBL.Visible = False
		btnTimeTo.Enabled = False ' xLBL.Visible = False
		chkday = 1
	Else
		Dim	tfrom As Long =  DateTime.datetimeParse(ChkDate,btnTimeFrom.xLBL.Text)
		Dim tto As Long = DateTime.datetimeParse(ChkDate,btnTimeTo.xLBL.Text)
		chkday=0
	End If
	Dialog.Initialize(Activity)
	DateTemplate.Date = Main.DateRet
	UpdateLabel
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub
